import bpy, mathutils
import bpy.ops
from bpy.props import *
from xml.etree.ElementTree import fromstring,Element



def fetchIfText (passedName= ""):
    try:
        result = bpy.data.texts[passedName]
    except:
        result = None
    return result


class CleanFCurvePanel(bpy.types.Panel):
    bl_label = "Clean Fcurve"
    bl_space_type = "GRAPH_EDITOR"
    bl_region_type = "UI"

    def draw(self, context):
        layout = self.layout


        layout.operator("fcurve.cleaner")

    @classmethod 
    def poll(self,context):
        #Fix this to poll for a mocapmadness rig perhaps.
        return True 

class FCurveCleaner(bpy.types.Operator):
    bl_idname = "fcurve.cleaner"
    bl_label = "Clean FCurve"
    threshold = FloatProperty("threshold",default=0.001,description="Threshold for the clean operator",min=0.001,max=0.1,precision=3)
    #self.threshold = 0.001
    
    def invoke(self, context, event):
        wm = context.window_manager
        return wm.invoke_props_dialog(self)

    def draw(self,context):
        layout = self.layout
        layout.prop(self,"threshold")
        print("DRAEWWWW")    
    def execute(self, context):
        print(self.threshold)
        global MocapMadnessXML
        if not MocapMadnessXML:
            return {'CANCELLED'}
        
        #Quick loop thru the actions in MocapMadnessXML
        
        Actions = MocapMadnessXML.findall("Actions/Action")   # list of actions
        rig = bpy.context.object
        for Action in Actions:
            action = bpy.data.actions[Action.get("name")]
            rig.animation_data.action = action
        
            bpy.ops.graph.clean(threshold=self.threshold)
        

        self.report("INFO","%d Actions Cleaned"%len(Actions))
      
        return{'FINISHED'}




def FetchMocapMadness(db):
    
    global MocapMadnessXML
    outputfile = fetchIfText(db)
    x = None     
    print(outputfile) 
     
    if outputfile != None :
        print("HERE")
        stringx = outputfile.as_string()
        print(stringx)
        #x = fromstring("<MocapMadness><Rigs/><Actions/></MocapMadness>")
        MocapMadnessXML = fromstring(stringx)
        print(x)
        #outputfile.clear()
    else:
        outputfile = bpy.data.texts.new(db)
        MocapMadnessXML = fromstring("<MocapMadness><Rigs/><Actions/></MocapMadness>")
        
    return True
    
MocapMadnessXML = None
FetchMocapMadness("MocapMadness.xml")


     
def register():
    bpy.utils.register_class(CleanFCurvePanel)
    bpy.utils.register_class(FCurveCleaner)


def unregister():
    bpy.utils.unregister_class(VacuumPanel)    
    bpy.utils.unregister_class(VacuumCleaner)
print(__name__)
if __name__ in ["__main__","cleanfcurve"]:
    register() 