import bpy
from bpy.props import *
import xml.etree.ElementTree as ET
from math import *  # enable maths functions to be used in default settings 

print("CONFIG FILE:%s"%__file__)

    
    
def InitMocapMadness(scn):
    global data
    bpy.types.Scene.MocapMadness = bpy.props.BoolProperty(
        name="Wired for Mocap Madness", 
        description="Wired for MocapMadness (set internally)")
    scn['MocapMadness'] = False
    data = FetchMocapMadness()
    if not data:
        data = defaultData()
    
    
    
def defaultSettings():
    settings = '''
        <Settings>
            <setting name="bvhimport" rot90="True" />
        </Settings>'''
    print("wooohooo")
    root = ET.XML(settings)
    return(ET.ElementTree(root))

def LoadSettings():
    import os
    Dir = os.path.dirname(__file__)
    path = os.path.join(Dir, 'settings.xml')
    # load settings from the addon. (can be user saved)
    settings = ET.parse(path)
    #print(ET.tostring(settings))
    return settings

settings = LoadSettings()
# Set operator settings from settings node
#


def SetOperatorProperties(name):
    #Not used.... 
    #name = class_def.mocapmadness_name
    global settings
    print("SET OPERATOR PROPERTIES: %s"%name)
    if not settings :
        return(False)

    cmds = []
    Settings = settings.findall('Settings[@name="%s"]/Setting'%name)
    
    for Setting in Settings:

        attrs = ["name","description"]
    
        default = False # Take out default value code.. settings 
        '''
        It's set by settings anyhow.. enables values like
        bpy.context.scene.fps
        to be used as default
        '''
        proptype = Setting.get("type")
        prop_name = Setting.get("prop_name")
        args = []
        
        if proptype in ["int","float"]:
            if default:
               def_value = eval("%s"%Setting.text)
            attrs.extend(["min","max","soft_min","soft_max","unit"])
        elif proptype in ["str"]:
            if default:
                def_value = '"%s"'%Setting.text
            attrs.extend(["maxlen"])
            proptype = "string"
        else:
            if default:
                def_value = eval("%s"%Setting.text)
        


           
        for attr in attrs :
            
            if Setting.get(attr):
                if attr == "default":
                    args.append('%s=%s'%(attr,def_value))
                elif attr in ["description","name"]:
                    args.append('%s="%s"'%(attr,Setting.get(attr)))
                else:
                    args.append('%s=%s'%(attr,Setting.get(attr)))
        
                
                        
                    
                    
                
        print("SETTING: %s %s"%(args,attrs))
        
        #name = Setting.get("name")
        expr = '%s =  %sProperty('%(prop_name,str.title(proptype))
        for arg in args:
            expr += '%s,'%arg
        expr += ")"
        print(expr)
        cmds.append(expr)
    return cmds
        #exec(expr)


def SetOperatorSettings(operator):
    name = operator.mocapmadness_name
    global settings
    print("GetSettings: %s"%name)
    if not settings :
        return(False)


    Settings = settings.findall('Settings[@name="%s"]/Setting'%name)
    for Setting in Settings:
        print("SETTING: %s"%Setting.text)
        if Setting.get("type") == "str":
            value = Setting.text
        else:    
            value = eval("%s"%Setting.text)
        expr = 'operator.%s =  value'%(Setting.get("prop_name"))
        exec(expr)
            
def PreserveSettings(operator):
    name = operator.mocapmadness_name
    global settings
    print("Preserve Settings:: %s"%name)
    if not settings :
        print("NO SETTINGS")
        return(False)


    Settings = settings.findall('Settings[@name="%s"]/Setting'%name)
    for Setting in Settings:

        value = eval('operator.%s'%Setting.get("prop_name"))
        if Setting.get("type") == "float":
            value = str(round(value,2))
        Setting.text = value
            

def defaultData():
    print("DefaultData")
    defaultdata = '''
        <MocapMadness>
            <Actions/>
            <Rigs/>
        </MocapMadness>'''
    root = ET.XML(defaultdata)
    
    return(ET.ElementTree(root))

def FetchMocapMadness():
    import os
    print("SCENE: %s"%bpy.context.scene)

    #Mocap madness is on for file and file has been saved
    default_path = os.path.splitext(bpy.data.filepath)[0] + ".mmxml"
    print("LOADING FROM: %s"%default_path)
    if os.path.isfile(default_path):
        data = ET.parse(default_path)
        return data
 
    if "MocapMadness.xml" in bpy.data.texts:
      
         input = bpy.data.texts["MocapMadness.xml"]
         #read the data from the texts
         str = input.as_string()
         
         root  = ET.XML(str)
         data = ET.ElementTree(root)
         #data.fromstring(str)
         print("FETCH")
         return data

    return None

##########################################################
# 
#  Load up the data if it exists. Prob if F8 has been hit
#
##########################################################

#data = FetchMocapMadness()
def WriteToText(name):
    global data
    # writes to the text editor .. MocapMadness.xml
    if name in bpy.data.texts:
        
        output = bpy.data.texts[name]
    else:
        output = bpy.data.texts.new(name)
        
    output.clear()   #clear it
    output.write(ET.tostring(data.getroot()).decode("utf-8"))
        
def Save():
    global data
    import os
    default_path = os.path.splitext(bpy.data.filepath)[0] + ".mmxml"
    
    if default_path == ".mmxml" :
        #Oh oh it's a new and unnamed file.. can't save
        #could use the text editor as a tempory holder
        #that can produce memory errors if file gets too big.
        print("No save until file created.")
        WriteToText("MocapMadness.xml")
        return(False)
    
    if data:
        data.write(default_path)
        return(True)        

data = None
#settings = None
