# Make a menu from the xml data.

import bpy
from xml.etree.ElementTree import fromstring,Element
from bpy.props import *
from mathutils import Euler,Matrix
'''
An 

'''
class PlayMocapList(bpy.types.Operator): 
    bl_idname = 'mocapmadness.playmocap' 
    bl_label = 'Play Mocaps'
    
    action = StringProperty("Action",default="Select Action") 

    def execute(self, context):

       print("Playing Mocaps")
       #get all the actions that have markers named after the rig
       rig = context.object
       action = bpy.data.actions[self.action]
       rig.animation_data.action = action
       context.scene.frame_set(1)
       context.scene.frame_end = action.frame_range[1]
       #bpy.ops.screen.animation_cancel()  
       mode = rig.mode
       bpy.ops.set_mode(mode="POSE")
       if mode == "POSE":
           bpy.ops.pose.paths_clear()
           bpy.ops.pose.select_all(action='DESELECT')
    
           rig.pose.bones[0].bone.select = True
           bpy.ops.pose.paths_calculate()
       #bpy.ops.screen.animation_play()
       bpy.ops.set_mode(mode=mode)
       #Playing = True
       #for action in bpy.data.actions :
          

       return {'FINISHED'} 

def createcycle(action,cyclenode,locator):
    
    REPEAT = 10
    # rig is the mocapmadness rig
    # cyclenode xml cycle node
    # location
    rig = bpy.context.object
    start_frame = float(cyclenode.get("from"))
    end_frame = float(cyclenode.get("to"))
    
    #use the hip locator to get the dzrot and translation vector.
    
  
    if "RigTrack" in rig.animation_data.nla_tracks:
        RigTrack = rig.animation_data.nla_tracks["RigTrack"]
    else:
        RigTrack = rig.animation_data.nla_tracks.new()
        RigTrack.name = "RigTrack"
        
    if "BvhTrack" in rig.animation_data.nla_tracks:
        BvhTrack = rig.animation_data.nla_tracks["BvhTrack"]
    else:
        BvhTrack = rig.animation_data.nla_tracks.new(RigTrack)
        BvhTrack.name = "BvhTrack"        
    if "RigAction" in bpy.data.actions:
        RigAction = bpy.data.actions["RigAction"]
    else:
        RigAction = bpy.data.actions.new("RigAction")
    
    
    cycleStrip = BvhTrack.strips.new("Cycle",start=1,action=action)
    cycleStrip.action_frame_start = start_frame
    cycleStrip.action_frame_end = end_frame - 1.0
    cycleStrip.repeat = REPEAT    
    bpy.context.scene.frame_set(1.00)
    loc0 = rig.matrix_world.to_translation()
    rotzA = locator.matrix_world.to_euler("XYZ").z
    bpy.context.scene.frame_set(start_frame)
    locA = locator.matrix_world.to_translation()
    bpy.context.scene.frame_set(end_frame)
    locB = locator.matrix_world.to_translation()
    
    rotzB = locator.matrix_world.to_euler("XYZ").z
    
    drotz = rotzB - rotzA # Z rotation
    
    #drot = Euler([0,0,drotz],"XYZ")

    dloc  = locA - loc0  # translation vector
    print(dloc)
    print(drotz)
    #print(dloc*drot.to_matrix())
    #print(dloc*rotmat)

    destVec = locB - loc0
    rotmat = Matrix.Rotation(drotz,3, "Z")
    length = end_frame -start_frame - 1 
    bpy.context.scene.frame_set(start_frame)
    i = 0
    rig.keyframe_insert("location",frame=i*length+1)
    rig.keyframe_insert("rotation_euler",index=2,frame=i*length+1)
    rig.animation_data.action = RigAction

    i = 0
    while i < REPEAT:


        dloc_r = (destVec - dloc*rotmat)
        rig.location +=  dloc_r
        rig.rotation_euler.z += drotz
        rig.keyframe_insert("location",frame=i*length+1)
        rig.keyframe_insert("rotation_euler",index=2,frame=i*length+1)
        destVec = destVec*rotmat
        dloc = dloc*rotmat
        i+=1
    for fcurve in RigAction.fcurves:
        for point in fcurve.keyframe_points:
            point.interpolation = 'CONSTANT'
            
    #bpy.ops.action.interpolation_type(type="CONSTANT")
    rigStrip = RigTrack.strips.new("blah",start=1,action=RigAction)
    rig.animation_data.action = action        
          
    return False
    

class View3DPanel():
    bl_space_type = 'NLA_EDITOR'
    bl_region_type = 'UI'

    @classmethod
    def poll(cls, context):
        return (context.object is not None)



class NLAPlayMocap(View3DPanel, bpy.types.Panel):
    bl_idname = "VIEW3D_PT_test_1"
    bl_label = "Play Mocap"

    def draw(self, context):
        layout = self.layout
        self.layout.label("MocapMadness Player")
        
        if context.object.animation_data.action:
            layout.prop(bpy.context.object.animation_data.action,"name")
        layout.menu("mocapmadness.actionmenu")
        #self.layout.operator("mocapmadness.compareposes")


class PanelTwo(View3DPanel, bpy.types.Panel):
    bl_idname = "VIEW3D_PT_test_2"
    bl_label = "Choose a Cycle"

    def draw(self, context):
        #self.layout.label("Cycles")
        self.layout.menu("mocapmadness.cyclemenu")
        self.layout.operator("mocapmadness.cycle",text="Next").next = True     
        
class BranchPanel(View3DPanel, bpy.types.Panel):
    bl_idname = "MocapMadness_BranchPanel"
    bl_label = "Choose a Branch"

    def draw(self, context):
        #self.layout.label("Cycles")
        self.layout.menu("mocapmadness.branchmenu")
                
class ActionMenu(bpy.types.Menu):
    bl_idname = "mocapmadness.actionmenu"
    bl_label = "Change Action"
    filter = 'Actions/Action'
    
    def draw(self,context):
        global MocapMadnessXML
        print("FILTER")
        print(self.filter)
        
        layout = self.layout

        Actions = MocapMadnessXML.findall(self.filter)
        for Action in Actions:
            layout.operator("mocapmadness.playmocap",text=Action.get("name")).action=Action.get("name")
            
class BranchMenu(bpy.types.Menu):
    bl_idname = "mocapmadness.branchmenu"
    bl_label = "Branch to Action"

    def draw(self, context):
        # Ok make the query
        action = context.object.animation_data.action
        frame_current = context.scene.frame_current
        branches = xmlData.findall('Actions/Action[@name="%s"]/branch[@from="%.1f"]'%(action.name,frame_current))
        
        layout = self.layout
        i = 0
        for branch in branches:

                
            text = "Branch to %s frame %s"%(branch.get("action"),branch.get("to"))  
            layout.operator("mocapmadness.cycle", text=text).cyclenode=i

            i += 1   
            
class CycleMenu(bpy.types.Menu):
    bl_idname = "mocapmadness.cyclemenu"
    bl_label = "Choose a Cycle"

    def draw(self, context):
        frame_current = context.scene.frame_current        
        action = context.object.animation_data.action
        #cycles = xmlData.findall('cycle[@action="%s" and @start_frame]'%action.name)
        cycles = xmlData.findall('Actions/Action[@name="%s"]/cycle[@from="%.1f"]'%(action.name,frame_current))        
        layout = self.layout
        i = 0
        for cycle in cycles:
            
            text = "Cycle To %s"%(cycle.get("to"))  
            layout.operator("mocapmadness.cycle", text=text).cyclenode=i
            #layout.operator("object.select_random", text="Random")
            i += 1
         
 
class MocapMadness_Cycle(bpy.types.Operator):
    bl_idname = "mocapmadness.cycle"
    bl_label = "Cycle"
    cyclenode = IntProperty("cycle",default=-1)
    next = BoolProperty("next",default=False)
    
   
    def execute(self, context):
        global MocapMadnessXML
        print(self.cyclenode)
        if self.next :
            frame_current = bpy.context.scene.frame_current
            action = bpy.context.object.animation_data.action
            # goto the frame that has the next cycle
            cycles = xmlData.findall('Actions/Action[@name="%s"]/cycle'%(action.name)) 
            
            for cycle in cycles:
               
                goto = float(cycle.get("from"))
                if goto > frame_current :
                    context.scene.frame_set(goto)
                    return {'FINISHED'}
                
        if self.cyclenode > -1 :
            action = context.object.animation_data.action
            #cycles = xmlData.findall('cycle[@action="%s" and @start_frame]'%action.name)
            cycles = xmlData.findall('Actions/Action[@name="%s"]/cycle'%(action.name))
            cyclenode = cycles[self.cyclenode]
            locator = bpy.data.objects["BVH16_01LOCATOR"]
            createcycle(action,cyclenode,locator)
                   
        return{'FINISHED'}
        #print(self.tolerance)
        #posecompare(tolerance,MIN_CYCLE_LENGTH=15,FRAMESTEP=2)

bpy.utils.register_class(ActionMenu)
bpy.utils.register_class(CycleMenu)
bpy.utils.register_class(BranchMenu)
bpy.utils.register_class(NLAPlayMocap)
bpy.utils.register_class(PanelTwo)
bpy.utils.register_class(BranchPanel)
bpy.utils.register_class(MocapMadness_Cycle)
bpy.utils.register_class(PlayMocapList)

