# ##### BEGIN GPL LICENSE BLOCK #####
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# ##### END GPL LICENSE BLOCK #####


bl_info = {
    "name": "Mocap Madness",
    "author": "batFINGER",
    "location": "Animation",
    "description": "Animation Mocap Madness",
    "warning": "Pre Alpha",
    "wiki_url": "",
    "tracker_url": "",
    "support": 'COMMUNITY',
    "category": "Animation"}



if "bpy" in locals():
    import imp
    imp.reload(MMData)
    imp.reload(utils)
    imp.reload(bvhimport)
    imp.reload(nla)
    imp.reload(space3d)
    imp.reload(graph)

    print("RELOADING**********************************")
else:
    print("IMPORTING**********************************")
    from . import MMData
    from . import bvhimport
    from . import nla
    from . import space3d
    from . import graph
    from . import utils

import bpy

print("LOAD MM %s"%__path__)
#config.data = config.FetchMocapMadness()
# only load in the MM db here if it's been set up

def register():
    #create a settings variable here
    #config.settings = config.LoadSettings(__path__[0])
    MMData.data = MMData.FetchMocapMadness()
    print("register")
    bvhimport.register()
    nla.register()
    space3d.register()
    graph.register()
    
def unregister():
    print("unregister")
    bvhimport.unregister()
    nla.unregister()
    space3d.unregister()
    graph.unregister()
    print("unregister")