import bpy
from bpy.props import *
from xml.etree.ElementTree import Element
from math import radians
import MocapMadness.MMData as mocapmadness
from threading import Thread
########################################################################
'''
POSE MATCHING SCRIPT

v 0.0.0

An attempt to find best match poses in an action collection and mark 
them in actions with markers


'''
########################################################################

def compare_fcurves(fcurves1,frame1,fcurves2,frame2,knockoff=100.0,MAX_EULER_ROT_DIFF=radians(10)):
    diff = 0.0
    
    '''
    BIG SCOPE for IMPROVEMENT HERE.. need to look at locs and rots to also ditch big rots
    
    make a class method.
    '''
    root = 'pose.bones["Hips"]'
    j = 0
    #fcurve1 = fcurves1[frame_index1]
    while j < len(fcurves1)-1:
        fcurve1 = fcurves1[j]
        fcurve2 = fcurves2[j]
        if fcurve1.data_path.find(root) < 0 :            
           #print("%d,%d"%(j,len(fcurves1)))
           df = abs(fcurve1.evaluate(frame1) - fcurve2.evaluate(frame2))
           #print(df)
           if diff > knockoff:
         
               return(1000.0)
           if fcurve1.data_path.find("rotation") >= 0 and df > MAX_EULER_ROT_DIFF : #work out how to use for quaternions
               #print("rotdiff")
               return(1000.0)
           diff += df
        j += 1
    #print(diff)
    return(diff)   

def posecompare(operator,tolerance,MIN_CYCLE_LENGTH=15,FRAMESTEP=2,MAX_EULER_ROT_DIFF=radians(5.0)): #Minimum Cycle length to set up.
    #ob = bpy.context.object
    

    # Will make it a class method
    Actions = mocapmadness.data.findall("Actions/Action")
    
    #return
    action = bpy.data.actions[0]
    fcurves = action.fcurves
    root = 'pose.bones["Hips"]'
    diff = 0
    action_index1 = 0

    
    while action_index1 < len(Actions) :
        action1 = bpy.data.actions[Actions[action_index1].get("name")]    
        print("ACTION:%s"%action1.name)
        operator.report("INFO","%s"%action1.name) 
        pts1 = action1.fcurves[0].keyframe_points
        frame = max(1,int(action1.frame_range[0]))
        while frame < action1.frame_range[1]:
        #for frame,pt in enumerate(pts1):
            # loop thru all the points the hips go thru
            diff = 0
             
            compare_fcurve = 0
           
            action_index2 = action_index1
            while action_index2 < len(Actions):
                
                action2 = bpy.data.actions[Actions[action_index2].get("name")]
                fcurves2 = action2.fcurves
                
                i = 0
                if action1 == action2 : # looking at cycles
                    i = frame + 1
    
                    pts2 = int(action2.frame_range[1])-1
                    # in the same action so work out cycles
                    while i < pts2:
                        #print(i)
                        start_frame = frame
                        end_frame = i
                        diff = 1000.00
                        # the root bone doesn't matter as it will be used to position armature at branch
                        if abs(start_frame - end_frame) >=  MIN_CYCLE_LENGTH : # another property to key in.
                            diff = compare_fcurves(action1.fcurves,frame,action2.fcurves,i,knockoff=tolerance,MAX_EULER_ROT_DIFF=MAX_EULER_ROT_DIFF)
                            if diff < tolerance: #lets look at frames at least ten away from current frame

                                print('\tcycle from="%.1f" to="%.1f" match="%.3f"'%(start_frame,end_frame,diff))
                                
                                
                                
                                cycle = Element("cycle")
                                cycle.set("from","%.1f"%start_frame)
                                cycle.set("to","%.1f"%end_frame)
                                cycle.set("match","%.2f"%diff)
                                Actions[action_index1].append(cycle)
                                
                                
                                
                        i+= FRAMESTEP   
                        
                else:
                        i = 1  ############ i = 0 is the rest pose will flag later
        
                        pts2 = int(action2.frame_range[1]) - 1
                        # in the same action so work out cycles
                        while i < pts2:
                            #print(i)
                           
                            
                            # the root bone doesn't matter as it will be used to position armature at branch
                            
                            diff = compare_fcurves(action1.fcurves,frame,action2.fcurves,i,knockoff=tolerance,MAX_EULER_ROT_DIFF=MAX_EULER_ROT_DIFF)
                            if diff < tolerance:
                                start_frame = frame
                                end_frame = i
                                branch1 = Element("branch")
                                branch1.set("action",action2.name)
                                branch1.set("from","%.1f"%start_frame)
                                branch1.set("to","%.1f"%end_frame)
                                branch1.set("match","%.2f"%diff)
                                branch2 = Element("branch")
                                branch2.set("action",action1.name)
                                branch2.set("from","%.1f"%end_frame)
                                branch2.set("to","%.1f"%start_frame)
                                branch2.set("match","%.2f"%diff)
                                Actions[action_index1].append(branch1)
                                Actions[action_index2].append(branch2)
                                print('\tbranch from_="%.1f" action="%s" to="%.1f" match="%.3f"'%(start_frame,action2.name,end_frame,diff))
                                #outputfile.write('\t<branch from_action="%s" from_frame="%.1f" to_action="%s" to_frame="%.1f" match="%.3f"/>\n'%(action2.name,end_frame,action1.name,start_frame,diff))
                            i+= FRAMESTEP             
                             #   print("comparing frame")
                      
                action_index2 += 1
            frame += FRAMESTEP
        action_index1 += 1             
    #mocapmadness.Save() # could save the branches to the file here.. will make it an option otherise it's a clutterer.  
             



class MocapMadness3DPanel():
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'

    @classmethod
    def poll(cls, context):

        return (mocapmadness.data is not None)



class MMComparePosePanel(MocapMadness3DPanel, bpy.types.Panel):
    bl_idname = "MMComparePoses"
    bl_label = "Compare Poses"
    
    @classmethod
    def poll(cls,context):

        
        return(mocapmadness.data != None)
    
    
    def draw(self, context):
        layout = self.layout
        layout.label(text = "Cycles:%d"%len(mocapmadness.data.findall("Actions/Action/cycle")))
        layout.label(text = "Branches:%d"%len(mocapmadness.data.findall("Actions/Action/branch")))
        layout.label("Small Class")
        layout.operator("mocapmadness.posecompare")
        layout.operator("mocapmadness.posecompare",text="Clean").clean=True


class MMPlayPanel(MocapMadness3DPanel, bpy.types.Panel):
    bl_idname = "VIEW3D_PT_test_2"
    bl_label = "Panel Two"
    
    @classmethod
    def poll(self,context):
        try:
            ad = context.object.animation_data or None
            if ad:
                return True
            
        except:
            return False
        return False
    
    #Going to be used as a play mocap panel
    def draw(self, context):
        layout = self.layout
        layout.menu("mocapmadness.actionmenu")
        self.layout.label("MocapMadness Player")
        if context.object.animation_data:
            action = context.object.animation_data.action or None
        
            if action:
                layout.prop(action,"name")
        
        #self.layout.operator("mocapmadness.compareposes")


class MocapMadness_ComparePoses(bpy.types.Operator):
    if mocapmadness.settings:
        print("GOT SETTINGS")
    bl_idname = "mocapmadness.posecompare"
    bl_label = "Compare Poses"
    bl_option = "REGISTER"
    mocapmadness_name = bl_idname
    print("COMPARE POSE OPERATOR CLASS DEF")
    for cmd in mocapmadness.SetOperatorProperties("mocapmadness.posecompare"):
        exec(cmd)
    clean = BoolProperty("Clean",default=False)
    
    #self.threshold = 0.001
    
    
    def clean_compare(self,context):
        #remove all the previous branches
        Actions = mocapmadness.data.findall("Actions/Action")
        print("cleaning %d cycles"%len(Actions))
        for Action in Actions:
            children = Action.findall("*") #// all childnodes
            for child in children:
                
                Action.remove(child)
        return True
        
    
    
    def invoke(self, context, event):
        mocapmadness.SetOperatorSettings(self)        
        wm = context.window_manager
        #return wm.invoke_props_dialog(self)        
        if not self.clean:
            
            return wm.invoke_props_dialog(self)
        else:
            print("clean")
            #return wm.invoke_popup(self)
        return self.execute(context)

    
    def draw(self,context):
        if self.clean:
            return
        layout = self.layout
        layout.prop(self,"tolerance")
        layout.prop(self,"max_euler_rot_Diff")
        layout.prop(self,"max_location_Diff")
        layout.prop(self,"framestep")
        layout.prop(self,"min_cycle_length")
        layout.prop(self,"Threaded",icon="ERROR")
        #print("DRAEWWWW")
            
    def execute(self, context):
        #posecompare(tolerance,MIN_CYCLE_LENGTH=15,FRAMESTEP=2)
        self.clean_compare(context)
        if self.clean:
            return{'FINISHED'} 
        
        
        if self.Threaded:
            t = Thread(target=posecompare,args=(self,self.tolerance, \
                       self.min_cycle_length,self.framestep,radians(self.max_euler_rot_Diff)))
            t.start()
        else:
            posecompare(operator=self,tolerance=self.tolerance,FRAMESTEP=self.framestep, \
                     MIN_CYCLE_LENGTH=self.min_cycle_length,MAX_EULER_ROT_DIFF=radians(self.max_euler_rot_Diff))
        mocapmadness.PreserveSettings(self)
        #bpy.ops.graph.clean(threshold=self.threshold)
        return{'FINISHED'} 



print("DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD")    


def register():
    bpy.utils.register_class(MMComparePosePanel)
    bpy.utils.register_class(MMPlayPanel)
    bpy.utils.register_class(MocapMadness_ComparePoses)
    
def unregister():
    bpy.utils.unregister_class(MMComparePosePanel)
    bpy.utils.unregister_class(MMPlayPanel)
    bpy.utils.unregister_class(MocapMadness_ComparePoses)